PROCEDURE ABORT (ABORT_CODE: INTEGER);
(*********************************************************************)
(*                                                                   *)
(*   THIS MODULE IS A COMPONENT OF DOOR SKELETON V1.0                *)
(*   COPYRIGHT (C) 1992 BERNIE GALLAGHER                             *)
(*                                                                   *)
(*********************************************************************)
(*                                                                   *)
(*   WHEN PASSED IORESULT OF THE LAST IO FUNCTION AS A PARM, WILL    *)
(*   PAUSE AND PROMPT THE LOCAL OPERATOR FOR ACTION.                 *)
(*                                                                   *)
(*********************************************************************)
VAR ACTION:                  STRING [1];
BEGIN

    IF ABORT_CODE > 0 THEN BEGIN

        WRITELN;
        WRITELN ('*** ABORT INTERCEPTED!');
        WRITELN ('    IORESULT .......... "', ABORT_CODE, '"');
        WRITELN ('    PROBABLE CAUSE .... "', TURBOMSG (ABORT_CODE), '"');
        HANG_UP;
        ACTION := '';
        WHILE LENGTH (ACTION) = 0 DO BEGIN

            WRITELN;
            WRITE ('[H]ALT, [R]EBOOT, [I]GNORE: ');
            READLN (ACTION);
            ACTION := STUPCASE (ACTION);
            IF ACTION = 'H' THEN HALT (ABORT_CODE)
            ELSE IF ACTION = 'R' THEN REBOOT
            ELSE IF ACTION = 'I' THEN EXIT
            ELSE BEGIN

                ACTION := '';
                WRITELN ('HUH?');
                END;

            END;

        END;

    END;

