PROCEDURE ADD_PLAYER (NEW_INDEX: INTEGER);
(*********************************************************************)
(*                                                                   *)
(*   THIS MODULE IS A COMPONENT OF DOOR SKELETON V1.0                *)
(*   COPYRIGHT (C) 1992 BERNIE GALLAGHER                             *)
(*                                                                   *)
(*********************************************************************)
(*                                                                   *)
(*   WILL ADD A NEW PLAYER RECORD TO THE PLAYER FILE                 *)
(*                                                                   *)
(*********************************************************************)
VAR LAST_INDEX:                  INTEGER;
VAR CLIMBING:                    BOOLEAN;
BEGIN

    SAVE_PLAYER := PLAYER;
    CLIMBING := TRUE;
    PLAYER_INDEX := 0;
    WHILE CLIMBING DO BEGIN

        ABORT (GET_PLAYER (PLAYER_INDEX));
        IF SAVE_PLAYER.NAMEKEY < PLAYER.NAMEKEY THEN BEGIN

            IF PLAYER.LEFT_CHILD > 0 THEN PLAYER_INDEX := PLAYER.LEFT_CHILD
            ELSE BEGIN

                PLAYER.LEFT_CHILD := NEW_INDEX;
                ABORT (PUT_PLAYER (PLAYER.INDEX));
                LAST_INDEX := PLAYER.INDEX;
                PLAYER := SAVE_PLAYER;
                PLAYER.PARENT := LAST_INDEX;
                ABORT (PUT_PLAYER (NEW_INDEX));
                CLIMBING := FALSE;
                END;

            END

        ELSE IF SAVE_PLAYER.NAMEKEY > PLAYER.NAMEKEY THEN BEGIN

            IF PLAYER.RIGHT_CHILD > 0 THEN PLAYER_INDEX := PLAYER.RIGHT_CHILD
            ELSE BEGIN

                PLAYER.RIGHT_CHILD := NEW_INDEX;
                ABORT (PUT_PLAYER (PLAYER.INDEX));
                LAST_INDEX := PLAYER.INDEX;
                PLAYER := SAVE_PLAYER;
                PLAYER.PARENT := LAST_INDEX;
                ABORT (PUT_PLAYER (NEW_INDEX));
                CLIMBING := FALSE;
                END;

            END

        ELSE CLIMBING := FALSE
        END;

    PLAYER_INDEX := NEW_INDEX;
    END;

