PROCEDURE CONFIG_MENU;
(*********************************************************************)
(*                                                                   *)
(*   THIS MODULE IS A COMPONENT OF DOOR SKELETON V1.0                *)
(*   COPYRIGHT (C) 1992 BERNIE GALLAGHER                             *)
(*                                                                   *)
(*********************************************************************)
(*                                                                   *)
(*   CONFIG MENU WHICH IS CALLED FROM THE MAINT MENU                 *)
(*                                                                   *)
(*********************************************************************)
VAR QUIT:                     BOOLEAN;
VAR OPTION:                   STRING [16];
BEGIN

    QUIT := FALSE;
    WHILE (NOT (QUIT)) DO BEGIN

        PUTSTRING (CR);
        PUTSTRING ('  [SESSIONS] ... MAX SESSIONS PER DAY ..... ' + FORMAT (NUMSTR (CONFIG.SESSIONS)) + CR);
        PUTSTRING ('  [TURNS] ...... MAX TURNS PER DAY ........ ' + FORMAT (NUMSTR (CONFIG.TURNS)) + CR);
        PUTSTRING ('  [TIME] ....... MAX MINUTES PER DAY ...... ' + FORMAT (NUMSTR (CONFIG.MINUTES)) + ' MINUTES' + CR);
        PUTSTRING ('  [SNOOP] ...... SNOOP .................... ' + YES_NO (CONFIG.SNOOP) + CR);
        PUTSTRING ('  [EXIT] ....... TO MAINT MENU' + CR);
        PUTSTRING (CR);
        OPTION := ASK_TEXT ('CONFIG:', 8);
        PUTSTRING (CR);
        IF MATCH (OPTION, 'EXIT') THEN QUIT := TRUE
        ELSE IF MATCH (OPTION, 'SESSIONS') THEN BEGIN

            CONFIG.SESSIONS := ASK_INTEGER ('MAX DAILY SESSIONS:', 1, 1000);
            END

        ELSE IF MATCH (OPTION, 'TURNS') THEN BEGIN

            CONFIG.TURNS := ASK_INTEGER ('MAX DAILY TURNS:', 1, 1000);
            END

        ELSE IF MATCH (OPTION, 'TIME') THEN BEGIN

            CONFIG.MINUTES := ASK_INTEGER ('TIME LIMIT PER SESSION (MINUTES):', 1, 1000);
            END

        ELSE IF MATCH (OPTION, 'SNOOP') THEN BEGIN

            CONFIG.SNOOP := ASK_TRUE ('SNOOP ON REMOTE PLAYERS:');
            END

        ELSE PUTSTRING ('INVALID OPTION "' + OPTION + '"!' + CR);
        END;

    ABORT (PUT_CONFIG (0));
    END;

