FUNCTION GETSTRING (L: INTEGER; S: STRING255): STRING255;
(*********************************************************************)
(*                                                                   *)
(*   THIS MODULE IS A COMPONENT OF DOOR SKELETON V1.0                *)
(*   COPYRIGHT (C) 1992 BERNIE GALLAGHER                             *)
(*                                                                   *)
(*********************************************************************)
(*                                                                   *)
(*   GET SCREEN INPUT FROM THE USER                                  *)
(*                                                                   *)
(*********************************************************************)
VAR C:                                         CHAR;
VAR TICK:                                      REAL;
VAR SAVE_UPCASE:                               BOOLEAN;
BEGIN

    IF (PLAYER_INDEX > 0) AND (NOT (SYSOP)) THEN BEGIN

        ABORT (GET_PLAYER (PLAYER_INDEX));
        PLAYER.MINUTES := PLAYER.MINUTES + MINUTES_USED;
        IF PLAYER.MINUTES > DOOR_MINUTES THEN BEGIN

            ABORT (PUT_PLAYER (PLAYER_INDEX));
            ALERT ('DAILY TIME LIMIT EXPIRED!');
            STOP;
            END;

        END;

    FREE_LOCK (NODE);
    LINE_COUNT := 0;
    SAVE_UPCASE := UPCASE_ONLY;
    UPCASE_ONLY := FALSE;
    ANSFORE (ANSGREEN);
    IF LOCAL THEN TEXTCOLOR (LIGHTGREEN);
    IF (CHAR_COUNT + L + 1) > SCREEN_WIDTH THEN PUTSTRING (CR);
    IF (CHAR_COUNT + L + 1) > SCREEN_WIDTH THEN L := SCREEN_WIDTH - 1;
    IF LENGTH (S) > L THEN S := COPY (S, 1, L);
    PUTSTRING (S);
    TICK := TIME;
    C := #0;
    WHILE (C <> CR) DO BEGIN

        IF ABS (TIME - TICK) > 600 THEN BEGIN

            ALERT ('INPUT TIMEOUT!');
            WAIT_LOCK (NODE, 15);
            STOP;
            END

        ELSE IF ABS (TIME - TICK) > 300 THEN BEGIN

            PUTSTRING (BELL);
            DELAY (750);
            END

        ELSE IF (REMOTE) AND (NOT (ASYNC_CARRIER)) THEN BEGIN

            HANG_UP;
            WAIT_LOCK (NODE, 60);
            STOP;
            END;

        IF GETCHAR (C) THEN BEGIN

            TICK := TIME;
            IF C = #29 THEN C := BS;
            IF C = CR THEN
            ELSE IF (C >= ' ') AND (C < #127) THEN BEGIN

                IF (LENGTH (S) < L) THEN BEGIN

                    PUTCHAR (C);
                    S := S + C;
                    END

                ELSE PUTCHAR (BELL);
                END

            ELSE IF C = BS THEN BEGIN

                IF LENGTH (S) > 0  THEN BEGIN

                    PUTCHAR (C);
                    PUTCHAR (' ');
                    PUTCHAR (C);
                    S := COPY (S, 1, LENGTH (S) - 1);
                    END

                ELSE PUTCHAR (BELL);
                END

            ELSE IF C <> LF THEN PUTCHAR (BELL);
            END;

        END;

    ANSFORE (ANSWHITE);
    TEXTCOLOR (WHITE);
    UPCASE_ONLY := SAVE_UPCASE;
    WAIT_LOCK (NODE, 15);
    GETSTRING := S;
    END;

