PROCEDURE INIT;
(*********************************************************************)
(*                                                                   *)
(*   THIS MODULE IS A COMPONENT OF DOOR SKELETON V1.0                *)
(*   COPYRIGHT (C) 1992 BERNIE GALLAGHER                             *)
(*                                                                   *)
(*********************************************************************)
(*                                                                   *)
(*   INITIALIZE THE GAME                                             *)
(*                                                                   *)
(*********************************************************************)
VAR PLAYER_KEY:   STRING [255];
BEGIN

    WAIT_LOCK (NODE, 30);
    PLAYER_KEY := STUPCASE (SQUISH (ALPHANUM (FIRST_NAME) + ' ' + ALPHANUM (LAST_NAME)));
    PLAYER_INDEX := FIND_PLAYER (PLAYER_KEY);
    IF PLAYER_INDEX = 0 THEN BEGIN

        CLEAR_PLAYER;
        PLAYER_INDEX := PLAYER_SIZE;
        PLAYER.NAMEKEY := PLAYER_KEY;
        PLAYER.FIRST_NAME := SQUISH (NAMECASE (FIRST_NAME));
        PLAYER.LAST_NAME := SQUISH (NAMECASE (LAST_NAME));
        ADD_PLAYER (PLAYER_INDEX);
        END;

    IF PLAYER.NODE = NODE THEN PLAYER.ACTIVE := FALSE;
    IF PLAYER.ACTIVE THEN BEGIN

        PUTSTRING (BELL);
        ANSBACK (ANSRED);
        PUTSTRING ('You are actively playing on node ' + FORMAT (NUMSTR (PLAYER.NODE)) + '!' + CR);
        PUTSTRING ('Split personalities are not allowed here!');
        ANSBACK (ANSBLUE);
        PUTSTRING (CR);
        PUTSTRING (CR);
        STOP;
        END;

    PLAYER.NODE := NODE;
    PLAYER.ACTIVE := TRUE;
    IF PLAYER.LAST_DATE_PLAYED = DATE THEN BEGIN

        PLAYER.SESSIONS := PLAYER.SESSIONS + 1;
        END

    ELSE BEGIN

        PLAYER.LAST_DATE_PLAYED := DATE;
        PLAYER.SESSIONS := 1;
        PLAYER.TURNS := 0;
        PLAYER.MINUTES := 0;
        END;

    DOOR_MINUTES := CONFIG.MINUTES;
    IF (BOARD_MINUTES < DOOR_MINUTES) THEN DOOR_MINUTES := BOARD_MINUTES;
    TIME_IN := TIME;
    ABORT (PUT_PLAYER (PLAYER_INDEX));
    STATUS (TRUE);
    IF LOCAL THEN SYSOP := TRUE
    ELSE IF (STUPCASE (SYSOP_FIRST_NAME) = STUPCASE (FIRST_NAME))
        AND (STUPCASE (SYSOP_LAST_NAME) = STUPCASE (LAST_NAME)) THEN SYSOP := TRUE;

    END;

