PROCEDURE PLAY;
(*********************************************************************)
(*                                                                   *)
(*   THIS MODULE IS A COMPONENT OF DOOR SKELETON V1.0                *)
(*   COPYRIGHT (C) 1992 BERNIE GALLAGHER                             *)
(*                                                                   *)
(*********************************************************************)
(*                                                                   *)
(*   THIS IS THE MODULE IN WHICH YOU WRITE THE CODE FOR YOUR DOOR    *)
(*                                                                   *)
(*********************************************************************)
VAR SAMPLE_TEXT_INPUT:      STRING [255];
VAR SAMPLE_NUMERIC_INPUT:   REAL;
VAR SAMPLE_BOOLEAN_INPUT:   BOOLEAN;
VAR SAMPLE_PLAYER_INDEX:    INTEGER;
VAR TOTAL_MINUTES:          INTEGER;
BEGIN




        { THIS IS WHERE YOU WRITE YOUR GAME }

        { EXAMPLES OF HOW TO COMMUNICATE WITH THE REMOTE PLAYER FOLLOW }




        { IN NEARLY ANY GAME, THE FIRST THING YOU WILL WANT TO DO }
        { IS RANDOMIZE THE RANDOM NUMBER GENERATOR }

    RANDOMIZE;





        { THIS IS AN EXAMPLE OF HOW TO SEND OUTPUT TO THE PLAYER }

        { ALWAYS USE  PUTSTRING  INSTEAD OF PASCAL'S WRITELN }

        { ANYTHING YOU DISPLAY USING WRITELN WILL ONLY BE SEEN ON }
        { ON THE LOCAL SCREEN BUT NOT BY THE REMOTE PLAYER }

    PUTSTRING ('HELLO ' + PLAYER.FIRST_NAME + '!' + CR);

        { NOTE THAT PUTSTRING DOES *NOT* AUTOMATICALLY ADD A CR/LF }
        { TO THE END OF EVERY LINE, YOU MUST USE THE PREDEFINED }
        { CONSTANT  CR  TO FORCE A CR/LF }







        { YOU MAY, OR MAY NOT, WANT TO TELL THE USER HOW MANY TURNS, }
        { SESSIONS, OR MINUTES THEY HAVE LEFT IN YOUR GAME }

    PUTSTRING ('YOU HAVE ' + FORMAT (NUMSTR (CONFIG.SESSIONS - PLAYER.SESSIONS + 1)) + ' SESSIONS LEFT TODAY' + CR);
    PUTSTRING ('YOU HAVE ' + FORMAT (NUMSTR (CONFIG.TURNS - PLAYER.TURNS)) + ' TURNS LEFT TODAY' + CR);
    TOTAL_MINUTES := MINUTES_USED + PLAYER.MINUTES;
    PUTSTRING ('YOU HAVE ' + FORMAT (NUMSTR (CONFIG.MINUTES - TOTAL_MINUTES)) + ' MINUTES LEFT TODAY' + CR);
    PUTSTRING ('YOU HAVE ' + FORMAT (NUMSTR (DOOR_MINUTES - TOTAL_MINUTES)) + ' MINUTES LEFT THIS SESSION' + CR);






        { THESE ARE EXAMPLES OF HOW TO GET INPUT FROM THE PLAYER }

    SAMPLE_TEXT_INPUT := ASK_TEXT ('SAY SOMETHING CLEVER:', 32);
    SAMPLE_NUMERIC_INPUT := ASK_NUMBER ('TYPE A NUMBER, ANY NUMBER:', -999999999999.0, 999999999999.0);
    SAMPLE_NUMERIC_INPUT := ASK_INTEGER ('TYPE AN INTEGER BETWEEN 10 AND 100:', 10, 100);
    SAMPLE_BOOLEAN_INPUT := ASK_TRUE ('ARE YOU HAPPY?');
    SAMPLE_NUMERIC_INPUT := ASK_DATE ('WHAT IS YOUR BIRTH DATE (YYYY/MM/DD)?');







        { THESE ARE EXAMPLES OF HOW TO USE THE OUTPUT FORMATTING }
        { FUNCTIONS }

    PUTSTRING ('TODAY''S DATE IS ' + DATESTR (DATE) + CR);

    PUTSTRING ('YOUR BIRTHDAY IS ' + DATESTR (SAMPLE_NUMERIC_INPUT) + CR);

    PUTSTRING ('YOU NOW HAVE ' + FORMAT (NUMSTR (PLAYER.WIDGETS)) + ' WIDGETS' + CR);






        { THE PASCAL VARIABLE   PLAYER_INDEX   POINTS TO THE RECORD }
        { OF THE PLAYER CURRENTLY ON LINE - DO NOT CHANGE THIS }
        { VARIABLE }

        { TO READ THE PLAYER'S INFO, USE FUNCTION GET_PLAYER }
        { ALL IO FUNCTIONS PASS BACK A RETURN CODE WHICH SHOULD }
        { USUALLY BE PASSED TO THE ABORT FUNCTION WHICH EXITS THE }
        { PROGRAM - YOU MAY WISH TO CHECK THE RETURN CODE YOURSELF }
        { AND PERFORM SOME OTHER PROCESSING }

    ABORT (GET_PLAYER (PLAYER_INDEX));






        { YOU MAY ADD ANY FIELDS YOU WISH TO THE PLAYER RECORD }

        { BUT DO NOT, UNDER ANY CIRCUMSTANCES, REMOVE ANY FIELDS }
        { THAT CAME PREDEFINED }

        { ALSO, DO NOT CHANGE ANY FIELDS THAT YOU DID NOT YOURSELF }
        { DEFINE }

    PLAYER.WIDGETS := PLAYER.WIDGETS + 1;





        { A NUMBER OF CONVERSION FUNCTIONS HAVE BEEN PROVIDED TO }
        { MAKE IT EASIER FOR YOU TO CONVERT USER INPUT FOR
        { CALCULATION, AND RESULTS FOR DISPLAY }

        { STRING := NUMSTR (REAL);                   CONVERTS A STRING TO A REAL }
        { REAL := STRNUM (STRING);                   CONVERTS A REAL TO A STRING }
        { STRING := FORMAT (STRING);                 ZERO SUPPRESSES A NUMBER }
        { STRING := STUPCASE (STRING);               CONVERTS TO ALL UPPER CASE }
        { STRING := NAMECASE (STRING);               CONVERTS 1ST CHAR TO UPPER }
        { BOOLEAN := NUMERIC (STRING);               TESTS IF A STRING IS A VALID NUMBER }
        { BOOLEAN := NUMERINT (STRING);              TESTS IF A STRING IS A VALID INTEGER }
        { BOOLEAN := VALDATE (STRING);               TESTS IF A STRING IS A VALID DATE }
        { STRING := SQUISH (STRING);                 REMOVES MULTIPLE BLANKS }
        { STRING := DBLANK (STRING);                 REMOVES ALL BLANKS }
        { STRING := ASK_TEXT (STRING, LENGTH);       PROMPTS FOR TEXT INPUT }
        { REAL := ASK_NUMBER (STRING, MIN, MAX);     PROMPTS FOR NUMERIC INPUT }
        { INTEGER := ASK_INTEGER (STRING, MIN, MAX); PROMPTS FOR NUMERIC INPUT }
        { BOOLEAN := ASK_TRUE (STRING);              PROMPTS FOR BOOLEAN INPUT }
        { REAL := ASK_DATE (STRING);                 PROMPTS FOR DATE INPUT }
        { STRING := DATESTR (REAL);                  CONVERTS A DATE-STRING TO A REAL }
        { REAL := STRDATE (STRING);                  CONVERTS A REAL TO A DATE-STRING }

        { OTHER FUNCTIONS HAVE ALSO BEEN INCLUDED - EXPERIMENT }
        { WITH THEM AND SEE WHAT THEY DO }







        { THIS IS AN EXAMPLE OF HOW TO USE THE RANDOM NUMBER }
        { FUNCTION - IT WILL RETURN AN INTEGER BETWEEN 0, AND ONE }
        { LESS THAN THE NUMBER YOU PASSED IT }

        { IN THE FOLLOWING EXAMPLE  RANDOM (3) WILL RETURN }
        { A RANDOM NUMBER OF 0, OR 1, OR 2 (BUT *NOT* 3)}

        { THE PLAYER WILL RANDOMLY RECEIVE 0, 1, OR 2 ADDITIONAL }
        { WIDGETS }


    PLAYER.WIDGETS := PLAYER.WIDGETS + RANDOM (3);

    PUTSTRING ('YOU HAVE EARNED ' + FORMAT (NUMSTR (PLAYER.WIDGETS)) + ' WIDGETS' + CR);





        { USE FUNCTION PUT_PLAYER TO UPDATE THE PLAYER RECORD }

    ABORT (PUT_PLAYER (PLAYER_INDEX));







        { YOU MAY READ/WRITE OTHER PLAYER'S RECORD BY USING ANOTHER }
        { VARIABLE }

    SAMPLE_PLAYER_INDEX := PLAYER_INDEX;

        { PRETEND YOU HAVE JUST LOADED SAMPLE_PLAYER_INDEX WITH }
        { THE INDEX OF A *DIFFERENT* PLAYER }

    ABORT (GET_PLAYER (SAMPLE_PLAYER_INDEX));

        { AND PRETEND THAT YOU HAVE JUST DEDUCTED FROM THE SCORE }
        { OF THE OPPONENT PLAYER }

    ABORT (PUT_PLAYER (SAMPLE_PLAYER_INDEX));

        { YOU MAY HAVE TO DEFINE SOME WORK VARIABLES IF YOU WANT }
        { TO WORK ON TWO PLAYERS AT THE SAME TIME }

        { THIS CAN BE VERY DANGEROUS - BE CAREFUL NOT TO OVERWRITE }
        { ONE PLAYER WITH ANOTHER PLAYER'S DATA }

        { ALWAYS RE-LOAD THE ACTIVE PLAYER RIGHT AFTER DOING }
        { SOMETHING WITH AN OPPONENT PLAYER! }

    ABORT (GET_PLAYER (PLAYER_INDEX));








        { ALWAYS SAVE THE ACTIVE PLAYER AFTER HE FINISHED A }
        { MAJOR MOVE OR ENDED THE GAME! }

    ABORT (PUT_PLAYER (PLAYER_INDEX));





    END;

