FUNCTION SET_LOCK (NODE: INTEGER): BOOLEAN;
(*********************************************************************)
(*                                                                   *)
(*   THIS MODULE IS A COMPONENT OF DOOR SKELETON V1.0                *)
(*   COPYRIGHT (C) 1992 BERNIE GALLAGHER                             *)
(*                                                                   *)
(*********************************************************************)
(*                                                                   *)
(*   SET THE LOCK RECORD - USUALLY DONE AT THE START OF THE PROGRAM  *)
(*   AND AFTER THE USER HAS ENTERED SOME INPUT                       *)
(*                                                                   *)
(*********************************************************************)
VAR TESTNODE:                      INTEGER;
VAR FILE_RESULT:                   INTEGER;
VAR OKAY:                          BOOLEAN;
BEGIN

    ASSIGN (LOCK_FILE, 'LOCK' + FORMAT (NUMSTR (NODE)));
    {$I-}
    RESET (LOCK_FILE);
    FILE_RESULT := IORESULT;
    {$I+}
    IF FILE_RESULT = 1 THEN BEGIN

        REWRITE (LOCK_FILE);
        END

    ELSE BEGIN

        SEEK (LOCK_FILE, 0);
        READ (LOCK_FILE, LOCK);
        END;

    LOCK.INUSE := TRUE;
    LOCK.INDEX := NODE;
    SEEK (LOCK_FILE, 0);
    WRITE (LOCK_FILE, LOCK);
    {$I-}
    CLOSE (LOCK_FILE);
    FILE_RESULT := IORESULT;
    {$I+}
    DELAY (100);
    OKAY := TRUE;
    FOR TESTNODE := 0 TO 4 DO BEGIN

        IF TESTNODE <> NODE THEN BEGIN

            ASSIGN (LOCK_FILE, 'LOCK' + FORMAT (NUMSTR (TESTNODE)));
            {$I-}
            RESET (LOCK_FILE);
            FILE_RESULT := IORESULT;
            {$I+}
            IF FILE_RESULT = 0 THEN BEGIN

                SEEK (LOCK_FILE, 0);
                READ (LOCK_FILE, LOCK);
                IF LOCK.INUSE THEN OKAY := FALSE;
                END

            ELSE IF FILE_RESULT > 1 THEN OKAY := FALSE;
            {$I-}
            CLOSE (LOCK_FILE);
            FILE_RESULT := IORESULT;
            {$I+}
            END;

        END;

    SET_LOCK := OKAY;
    END;

