PROCEDURE START;
(*********************************************************************)
(*                                                                   *)
(*   THIS MODULE IS A COMPONENT OF DOOR SKELETON V1.0                *)
(*   COPYRIGHT (C) 1992 BERNIE GALLAGHER                             *)
(*                                                                   *)
(*********************************************************************)
(*                                                                   *)
(*   START THE PROGRAM                                               *)
(*                                                                   *)
(*********************************************************************)
VAR PARAMETER:               STRING [80];
VAR FILENAME:                STRING [64];
VAR TEMP_BUFFER:             STRING [80];
VAR TEXTFILE:                TEXT;
VAR I:                       INTEGER;
VAR ASKING:                  BOOLEAN;
BEGIN

    BBSNAME := '';
    ANSI := FALSE;
    SCREEN_WIDTH := 80;
    SCREEN_LENGTH := 24;
    CHAR_COUNT := 0;
    LINE_COUNT := 0;
    NODE := 0;
    PLAYER_INDEX := 0;
    COMPORT := 0;
    SYSOP := FALSE;
    BULLETIN_NAME := '';
    IF PARAMCOUNT > 0 THEN BEGIN

        PARAMETER := PARAMSTR (1);
        IF NUMERIC (PARAMETER) THEN BEGIN

            NODE := TRUNC (STRNUM (PARAMETER));
            IF NODE <> STRNUM (PARAMETER) THEN BEGIN

                PUTSTRING ('NODE parameter invalid!' + CR);
                HALT;
                END;

            IF (NODE < 0) OR (NODE > 4) THEN BEGIN

                PUTSTRING ('NODE parameter out of range 0 thru 4!' + CR);
                HALT;
                END;

            END

        ELSE BEGIN

            PUTSTRING ('NODE parameter not numeric!' + CR);
            HALT;
            END;

        IF PARAMCOUNT > 1 THEN BEGIN

            BULLETIN_NAME := STUPCASE (PARAMSTR (2));
            END;

        END;

    ABORT (DEF_CONFIG);
    ABORT (GET_CONFIG (0));

    ABORT (DEF_PLAYER);
    ABORT (GET_PLAYER (0));


    { IF YOU DEFINE ANY ADDITIONAL FILES AND USE MY FILE SYSTEM }
    { YOU SHOULD PLACE YOUR "DEF" AND "GET (0)" HERE }


    BOARD_MINUTES := CONFIG.MINUTES;
    IF (NODE = 0) THEN BEGIN

        TEXTCOLOR (WHITE);
        TEXTBACKGROUND (BLUE);
        CLRSCR;
        CRLF := TRUE;
        ECHO := TRUE;
        LOCAL := TRUE;
        NULLS := FALSE;
        ONLINE := FALSE;
        REMOTE := FALSE;
        MODEM := FALSE;
        UPCASE_ONLY := FALSE;
        SYSOP_FIRST_NAME := '';
        SYSOP_LAST_NAME := '';
        COPYRIGHT;
        ASKING := TRUE;
        WHILE ASKING DO BEGIN

            FIRST_NAME := ASK_TEXT ('WHAT IS YOUR FIRST NAME? ', 32);
            LAST_NAME := ASK_TEXT ('WHAT IS YOUR LAST NAME? ', 32);
            PUTSTRING (CR);
            IF ASK_TRUE ('ARE YOU "' + NAMECASE (FIRST_NAME + ' ' + LAST_NAME) + '"?') THEN ASKING := FALSE;
            PUTSTRING (CR);
            END;

        MAIN;
        END

    ELSE BEGIN

        TEMP_BUFFER := DBLANK (FORMAT (NUMSTR (NODE)));
        FILENAME := 'CALLINFO.' + TEMP_BUFFER;
        ASSIGN (TEXTFILE, FILENAME);
        {$I-}
        RESET (TEXTFILE);
        {$I+}
        IF IORESULT > 0 THEN BEGIN

            FILENAME := 'DORINFO' + TEMP_BUFFER + '.DEF';
            ASSIGN (TEXTFILE, FILENAME);
            {$I-}
            RESET (TEXTFILE);
            {$I+}
            IF IORESULT > 0 THEN BEGIN

                WRITELN ('User info file for NODE "', TEMP_BUFFER, '" not found!');
                HALT;
                END;

            END;

        TEMP_BUFFER := '';
        READLN (TEXTFILE, BBSNAME);
        READLN (TEXTFILE, SYSOP_FIRST_NAME);
        READLN (TEXTFILE, SYSOP_LAST_NAME);
        READLN (TEXTFILE, TEMP_BUFFER);
        COMPORT := 0;
        FOR I := 1 TO LENGTH (TEMP_BUFFER) DO BEGIN

            IF NUMERIC (COPY (TEMP_BUFFER, I, 1)) THEN BEGIN

                COMPORT := TRUNC (COMPORT * 10.0) + TRUNC (STRNUM (COPY (TEMP_BUFFER, I, 1)));
                END;

            END;

        READLN (TEXTFILE, TEMP_BUFFER);
        MODEM_SPEED := TRUNC (STRNUM (COPY (TEMP_BUFFER, 1, POS (' ', TEMP_BUFFER + ' ') - 1)));
        READLN (TEXTFILE, TEMP_BUFFER);
        READLN (TEXTFILE, FIRST_NAME);
        READLN (TEXTFILE, LAST_NAME);
        IF NOT (EOF (TEXTFILE)) THEN READLN (TEXTFILE, TEMP_BUFFER);
        IF NOT (EOF (TEXTFILE)) THEN BEGIN

            READLN (TEXTFILE, TEMP_BUFFER);
            IF DBLANK (TEMP_BUFFER) = '2' THEN ANSI := TRUE;
            END;

        IF NOT (EOF (TEXTFILE)) THEN READLN (TEXTFILE, TEMP_BUFFER);
        IF NOT (EOF (TEXTFILE)) THEN BEGIN

            READLN (TEXTFILE, TEMP_BUFFER);
            IF NUMERINT (TEMP_BUFFER) THEN BEGIN

                BOARD_MINUTES := TRUNC (STRNUM (TEMP_BUFFER));
                END;

            END;

        IF NOT (EOF (TEXTFILE)) THEN READLN (TEXTFILE, TEMP_BUFFER);
        IF NOT (EOF (TEXTFILE)) THEN BEGIN

            READLN (TEXTFILE, TEMP_BUFFER);
            TEMP_BUFFER := DBLANK (TEMP_BUFFER);
            IF NUMERIC (TEMP_BUFFER) THEN SCREEN_WIDTH := TRUNC (STRNUM (TEMP_BUFFER));
            END;

        IF NOT (EOF (TEXTFILE)) THEN BEGIN

            READLN (TEXTFILE, TEMP_BUFFER);
            TEMP_BUFFER := DBLANK (TEMP_BUFFER);
            IF NUMERIC (TEMP_BUFFER) THEN SCREEN_LENGTH := TRUNC (STRNUM (TEMP_BUFFER));
            END;

        CLOSE (TEXTFILE);
        IF ASYNC_OPEN (COMPORT, MODEM_SPEED) THEN BEGIN

            ASYNC_READY (TRUE);
            ASYNC_CLEAR;
            CRLF := TRUE;
            ECHO := TRUE;
            LOCAL := FALSE;
            NULLS := TRUE;
            ONLINE := TRUE;
            REMOTE := TRUE;
            MODEM := FALSE;
            END

        ELSE BEGIN

            ASYNC_CLOSE;
            WRITELN ('ASYNC OPEN ERROR!');
            HALT;
            END;

        TEXTCOLOR (WHITE);
        TEXTBACKGROUND (BLUE);
        CLRSCR;
        ANSFORE (ANSWHITE);
        ANSBACK (ANSBLUE);
        ANSCLEAR (ANSBLUE);
        COPYRIGHT;
        MAIN;
        ASYNC_CLOSE;
        END;

    TEXTBACKGROUND (BLACK);
    CLRSCR;
    END;

