FUNCTION STRDATE (DATE_IN: STRING255): REAL;
(*********************************************************************)
(*                                                                   *)
(*   THIS MODULE IS A COMPONENT OF DOOR SKELETON V1.0                *)
(*   COPYRIGHT (C) 1992 BERNIE GALLAGHER                             *)
(*                                                                   *)
(*********************************************************************)
(*                                                                   *)
(*   CONVERTS A STRING FORMAT DATE "YYYY/MM/DD" TO A REAL FORMAT     *)
(*   DATE YYYYMMDD.0                                                 *)
(*                                                                   *)
(*********************************************************************)
VAR S_YEAR:                            STRING [8];
VAR S_MONTH:                           STRING [8];
VAR S_DAY:                             STRING [8];
VAR N_YEAR:                            REAL;
VAR N_MONTH:                           REAL;
VAR N_DAY:                             REAL;
BEGIN

    S_YEAR := COPY (DATE_IN, 1, POS ('/', DATE_IN) - 1);
    S_MONTH := COPY (DATE_IN, POS ('/', DATE_IN) + 1, LENGTH (DATE_IN));
    S_MONTH := COPY (S_MONTH, 1, POS ('/', S_MONTH) - 1);
    S_DAY := COPY (DATE_IN, POS ('/', DATE_IN) + 1, LENGTH (DATE_IN));
    S_DAY := COPY (S_DAY, POS ('/', S_DAY) + 1, LENGTH (S_DAY));
    N_YEAR := TRUNC (STRNUM (S_YEAR)) * 1.0;
    N_MONTH := TRUNC (STRNUM (S_MONTH)) * 1.0;
    N_DAY := TRUNC (STRNUM (S_DAY)) * 1.0;
    STRDATE := (N_YEAR * 10000.0) + (N_MONTH * 100.0) + N_DAY;
    END;

