FUNCTION TIME: REAL;
(*********************************************************************)
(*                                                                   *)
(*   THIS MODULE IS A COMPONENT OF DOOR SKELETON V1.0                *)
(*   COPYRIGHT (C) 1992 BERNIE GALLAGHER                             *)
(*                                                                   *)
(*********************************************************************)
(*                                                                   *)
(*   RETURNS RAW TIME FROM DOS (SECONDS SINCE LAST MIDNIGHT)         *)
(*                                                                   *)
(*   (USE THE CLOCK FUNCTION TO CONVERT TO HHMMSS.0)                 *)
(*                                                                   *)
(*   (USE THE TIMESTR FUNCTION TO CONVERT HHMMSS.0 TO "HH:MM:SS"     *)
(*                                                                   *)
(*********************************************************************)
VAR REGS:      REGISTERS;
VAR H:         REAL;
VAR M:         REAL;
VAR S:         REAL;
VAR T:         REAL;
BEGIN

    REGS.AX := 44 * 256;
    MSDOS (REGS);
    H := (REGS.CX DIV 256);
    M := (REGS.CX MOD 256);
    S := (REGS.DX DIV 256);
    T := (REGS.DX MOD 256);
    TIME := (H * 3600) + (M * 60) + S + (T / 100);
    END;

