FUNCTION TURBOMSG (ABORT_CODE: INTEGER): STRING255;
(*********************************************************************)
(*                                                                   *)
(*   THIS MODULE IS A COMPONENT OF DOOR SKELETON V1.0                *)
(*   COPYRIGHT (C) 1992 BERNIE GALLAGHER                             *)
(*                                                                   *)
(*********************************************************************)
(*                                                                   *)
(*   ERROR MESSAGES FOR ALL POSSIBLE IO ERROR CONDITIONS             *)
(*                                                                   *)
(*   REMOVE THIS FUNCTION IF YOUR PROGRAM IS TIGHT FOR SPACE         *)
(*                                                                   *)
(*********************************************************************)
VAR TEMP_MESSAGE:                         STRING255;
BEGIN

    TEMP_MESSAGE := '';
    IF ABORT_CODE = $0 THEN TEMP_MESSAGE := 'NORMAL COMPLETION'
    ELSE IF ABORT_CODE = $01 THEN TEMP_MESSAGE := 'FILE DOES NOT EXIST'
    ELSE IF ABORT_CODE = $02 THEN TEMP_MESSAGE := 'FILE NOT OPEN FOR INPUT'
    ELSE IF ABORT_CODE = $03 THEN TEMP_MESSAGE := 'FILE NOT OPEN FOR OUTPUT'
    ELSE IF ABORT_CODE = $04 THEN TEMP_MESSAGE := 'FILE NOT OPEN'
    ELSE IF ABORT_CODE = $05 THEN TEMP_MESSAGE := 'FILE ALREADY EXISTS'
    ELSE IF ABORT_CODE = $06 THEN TEMP_MESSAGE := 'SEEK BEYOND END OF FILE'
    ELSE IF ABORT_CODE = $07 THEN TEMP_MESSAGE := 'INVALID INDEX'
    ELSE IF ABORT_CODE = $10 THEN TEMP_MESSAGE := 'NUMERIC FORMAT ERROR'
    ELSE IF ABORT_CODE = $20 THEN TEMP_MESSAGE := 'NOT ALLOWED IN DIRECT MODE'
    ELSE IF ABORT_CODE = $22 THEN TEMP_MESSAGE := 'ASSIGN TO STD FILES NOT ALLOWED'
    ELSE IF ABORT_CODE = $90 THEN TEMP_MESSAGE := 'RECORD LENGTH MISMATCH'
    ELSE IF ABORT_CODE = $99 THEN TEMP_MESSAGE := 'END OF FILE'
    ELSE IF ABORT_CODE = $F0 THEN TEMP_MESSAGE := 'NO SPACE ON VOLUME'
    ELSE IF ABORT_CODE = $F1 THEN TEMP_MESSAGE := 'DIRECTORY IS FULL'
    ELSE IF ABORT_CODE = $F2 THEN TEMP_MESSAGE := 'FILE SIZE OVERFLOW'
    ELSE IF ABORT_CODE = $F3 THEN TEMP_MESSAGE := 'NO FILE HANDLES AVAILABLE'
    ELSE IF ABORT_CODE = $FF THEN TEMP_MESSAGE := 'FILE NOT DEFINED'
    ELSE TEMP_MESSAGE := 'GEE, I DUNNO...';
    TURBOMSG := TEMP_MESSAGE;
    END;

