FUNCTION VALDATE (DATE_IN: STRING255): BOOLEAN;
(*********************************************************************)
(*                                                                   *)
(*   THIS MODULE IS A COMPONENT OF DOOR SKELETON V1.0                *)
(*   COPYRIGHT (C) 1992 BERNIE GALLAGHER                             *)
(*                                                                   *)
(*********************************************************************)
(*                                                                   *)
(*   CHECK THAT A TEXT FORMAT DATE IS IN VALID FORMAT "YYYY/MM/DD"   *)
(*                                                                   *)
(*********************************************************************)
VAR S_YEAR:                            STRING [8];
VAR S_MONTH:                           STRING [8];
VAR S_DAY:                             STRING [8];
VAR N_YEAR:                            INTEGER;
VAR N_MONTH:                           INTEGER;
VAR N_DAY:                             INTEGER;
VAR FLAG:                              BOOLEAN;
BEGIN

    FLAG := FALSE;
    IF POS ('/', DATE_IN) > 0 THEN BEGIN

        S_YEAR := COPY (DATE_IN, 1, POS ('/', DATE_IN) - 1);
        IF NUMERINT (S_YEAR) THEN BEGIN

            S_MONTH := COPY (DATE_IN, POS ('/', DATE_IN) + 1, LENGTH (DATE_IN));
            IF POS ('/', S_MONTH) > 0 THEN BEGIN

                S_MONTH := COPY (S_MONTH, 1, POS ('/', S_MONTH) - 1);
                IF NUMERINT (S_MONTH) THEN BEGIN

                    S_DAY := COPY (DATE_IN, POS ('/', DATE_IN) + 1, LENGTH (DATE_IN));
                    S_DAY := COPY (S_DAY, POS ('/', S_DAY) + 1, LENGTH (S_DAY));
                    IF NUMERINT (S_DAY) THEN FLAG := TRUE;
                    N_YEAR := TRUNC (STRNUM (S_YEAR));
                    IF (N_YEAR * 1.0) <> STRNUM (S_YEAR) THEN FLAG := FALSE;
                    N_MONTH := TRUNC (STRNUM (S_MONTH));
                    IF (N_MONTH * 1.0) <> STRNUM (S_MONTH) THEN FLAG := FALSE;
                    IF (N_MONTH < 1) OR (N_MONTH > 12) THEN FLAG := FALSE;
                    N_DAY := TRUNC (STRNUM (S_DAY));
                    IF (N_DAY * 1.0) <> STRNUM (S_DAY) THEN FLAG := FALSE;
                    IF (N_DAY < 1) OR (N_DAY > 31) THEN FLAG := FALSE;
                    END;

                END;

            END;

        END;

    VALDATE := FLAG;
    END;

